<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="modalReturnBtn = true" style="margin-bottom:2.5rem"></ReturnButton>
    </header>

   <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title=" 'ALMACEN DE ' + (itemTelevisa.originalTitle).toUpperCase()"  bgColor="background-color: #818181 !important"> </app-title>
    </div>

    <!-- CARDS  -->
      <el-main style="margin:3rem 8rem">
        <el-row>
          <el-col >
            <el-collapse class="recept-accordion" style="margin-bottom:3rem">
              <el-collapse-item class="recept-accordion-child">
                <template slot="title">
                  <el-row>
                    <el-col :span="20">
                      <div class="recept-accordion-title">
                        <i class="el-icon-caret-right"></i>
                        <div class="box-title">
                          <span class="title-accordion">{{ itemTelevisa.originalTitle }}</span>
                          <span class="text-bold text-red" style="font-size:14px; margin-left:2rem">{{itemTelevisa.infoSupport[0].showreplace}}</span>
                        </div>
                      </div>
                      <div class="recept-accordion-status">
                        <el-radio v-model="itemTelevisa.infoSupport[0].stateStorage" label="Pendiente" > Pendiente </el-radio>
                        <el-radio v-model="itemTelevisa.infoSupport[0].stateStorage" label="Copiado" > Copiado </el-radio>
                      </div>
                    </el-col>
                    <el-col :span="4" style="text-align: center; margin-top: 20px;">
                      <img src="../../../../assets/images/borrador-rojo.svg" @click="ModalClean" >
                    </el-col>
                  </el-row>
                </template>
                <div>
                  <el-row style="margin: 3rem 0px 25px; background: #E0E0E0; padding: 2px 8px; font-size: 15px;">
                    <el-col :span="12">
                      <h4 class="text-green"> COPIA DE BACK UP: </h4>
                    </el-col>
                    <el-col :span="4">
                      <el-radio  v-model="itemTelevisa.infoSupport[0].copyBackup" label="SÍ"> SÍ </el-radio>
                    </el-col>
                    <el-col :span="4">
                      <el-radio  v-model="itemTelevisa.infoSupport[0].copyBackup" label="NO"> NO </el-radio>
                    </el-col>
                  </el-row>
                   <el-row style="margin-top: 3rem">
                     <el-col :span="12">
                        <h3 class="text-orange" style="margin:0 0 1rem"> ALMACENAMIENTO: </h3>            
    
                        <el-row style="margin: 12px 0;" type="flex" align="middle">
                          <el-col :span="12" class="subtitles-chapter-form">
                            Fecha de Copiado:
                          </el-col>
                          <el-col :span="12">						
                            <el-date-picker style="width: 100%"
                              v-model="itemTelevisa.infoSupport[0].dateOfCopy" type="date" format="dd/MM/yyyy" value-format="timestamp">
                            </el-date-picker>
                          </el-col>
                        </el-row>

                        <el-row style="margin: 12px 0;" type="flex" align="middle">
                          <el-col :span="12" class="subtitles-chapter-form">
                            Almacenamiento:
                          </el-col>
                          <el-col :span="15" >
                            <app-select v-model="itemTelevisa.infoSupport[0].storages" :filterArray="allstorages"  ></app-select>
                          </el-col>
                        </el-row>

                        <el-row style="margin: 12px 0;" type="flex" align="middle">
                          <el-col :span="12" class="subtitles-chapter-form">
                            Videoteca:
                          </el-col>
                          <el-col :span="15" >
                            <app-select v-model="itemTelevisa.infoSupport[0].videoteca" :filterArray="videotecaArray"  ></app-select>
                          </el-col>
                        </el-row>

                     </el-col>
                       
                     <el-col :span="10" :offset="2">
                       <h3 class="text-orange" style="margin:0 0 1rem">SOPORTE:</h3>

                       <div>
                           <el-row  v-for="(typeStorage, i) in itemTelevisa.infoSupport[0].supportMaterial" :key="i">
                            <el-col>
                              <el-col class="subtitles-chapter-form"> Soporte de Almacén: </el-col> 
                                <el-col :span="14" style="margin:0.5rem 0">
                                  <app-select v-model="typeStorage.typeStorage" :filterArray="typeStorageArray" size="small" ></app-select>
                                </el-col>
                              <el-col  :span="1" style="margin:0.5rem 0.5rem">
                                <span> <i @click="addElement( itemTelevisa.infoSupport[0].supportMaterial, i )" class="el-icon-circle-plus text-orange" style="font-size:25px"></i> </span>
                              </el-col>                             
                              <el-col v-if="itemTelevisa.infoSupport[0].supportMaterial.length > 1" :span="1" style="margin:0.5rem 0.5rem">
                                <span > <i @click="removeElement( itemTelevisa.infoSupport[0].supportMaterial, i )" class="el-icon-remove text-gray" style="font-size:25px; margin-left: 4px"></i> </span>
                              </el-col>
                            </el-col>
                            <el-col style="margin-bottom: 1rem">
                              <el-col style="margin-top:0.5rem" class="subtitles-chapter-form"> Código de Disco: </el-col>
                              <el-col :span="12">
                                <el-input v-model="typeStorage.codeDisk" size="small" :disabled="isChooseCopyBackup(itemTelevisa.infoSupport[0].copyBackup)"></el-input>
                              </el-col>          
                            </el-col>
                          </el-row>  
                      </div>
                                
                     </el-col> 
                   </el-row>
                </div>
              </el-collapse-item>
            </el-collapse>
         </el-col>
      </el-row>
    </el-main>

      <section style="margin:5rem 6rem 4rem 6rem">      
        <el-row>
          <el-col :span="2" :offset="17">
            <el-button  size="medium" v-on:click="modalCancelButton = true"  type="primary" plain>CANCELAR </el-button>                          
          </el-col>
          <el-col :span="1" :offset="2">
            <el-button size="medium" @click="enterNewOrder" type="primary"> REGISTRAR </el-button>  
          </el-col>
        </el-row>  
      </section>

    <!-- Modal botón copiar-->
     <app-modal :show-dialog.sync="modalCopy" v-if="modalCopy"  nameClass="dialog-orange" :rutImg="require(`../../../../assets/images/suspicious.svg`)" sizeImg="80px" textBold="¡Un momento!" typeBtn1="primary"
     :parrafo="'¿Quieres <strong>'+  copy   + '</strong> la informacion en todos los capítulos? ' "
      classBtn1="border-orange" btn1="SI, COPÍAR" btn2="CANCELAR"  @btnEvent="btnCopiar" v-on:eventBtn="modalCopy = false">
    </app-modal>

      <!-- Modal botón ingresar-->
    <!-- :parrafo="'Se guardó la información de los capítulos de <strong>' + itemSupportMat.originalTitle + ' <strong>'" -->

    <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" 
    :parrafo="'Se guardó la información de la recepción de los capítulos'"
      btn1="ACEPTAR" @btnEvent="enterSupportModal = false" v-on:btnEvent="returnPage" >
    </AppModalSuccess>

    <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage"  @btnEvent="modalReturnBtn = false" v-on:eventBtn="modalReturnBtn = false">
    </AppModalDanger> 

    <!-- Modal del borrardor -->
    <app-modal :show-dialog.sync="clean" v-if="clean" nameClass="dialog-red" :rutImg="require(`../../../../assets/images/alerta.svg`)" sizeImg="65px" textBold="¡Un momento!"
      :parrafo="'¿Seguro de que quieres borrar la informacion ingresada?'" classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR" @btnEvent="borrarInfo" v-on:eventBtn="clean = false" >
    </app-modal>


  </div>
</template>

<script>
  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'  
  import SearchFilter from '@/components/searchFilter.vue'
  import { HTTP } from '../../../../main.js' 
  import Select from '@/components/AppSelect.vue'
  import AppModal from '@/components/AppModal.vue'
  import AppModalSuccess from '@/components/AppModalSuccess.vue'
  import AppModalDanger from '@/components/AppModalDanger.vue'
  import { modifyText } from '../../../../utils/modifyText.js'
  // import {isChooseCopyBackup} from '@/utils/util.js'

  export default {
    components: {
      ReturnButton,
      AppModalSuccess,
      AppModalDanger,
     'app-search-filter': SearchFilter, 
     'app-title': Title,
     'app-select': Select,
     'app-modal': AppModal
    },
    data() {
      return {
        clean: false,
        modalReturnBtn: false,
        stateBtnSup: JSON.parse(this.$localStorage.get("stateBtnSup")), 
        itemStorage: {},
        enterSupportModal: false,
        modalCancelButton: false,
        indexStorage: 0,
        textSearch: '',
        idSupportMat: JSON.parse(this.$localStorage.get("idSupportMat")),
        // itemTelevisa: JSON.parse(this.$localStorage.get("itemTelevisa")),
        itemTelevisa: JSON.parse(this.$localStorage.get("itemSeleccionado")), 
        // itemSupportMat: [],
        season: [],
        selectItems: [],
        textarea3: '',
        checked: false,
        temporada: '',
        seasonFilterByTemp: {},
        // stateStorage: '',
        modalCopy: false,
        copy: 'copiar',
        indexTemp: 0,
        indexItemCap: 0,
        itemCap: {}, 

        // televisa
        allShipping: [],
        methodsArrival: [],
        stateBtnStorageSupport: JSON.parse(this.$localStorage.get("stateBtnStorageSupport")), 
        allstorages: [
          {value: 'Master', label: 'Master'},
          {value: 'Producción Nacional', label: 'Producción Nacional'},
        ],

        videotecaArray: [
          {value: 'Santa Beatriz', label: 'Santa Beatriz'},
          {value: 'Pachacamac', label: 'Pachacamac'},
        ],

        typeStorageArray: [
          {value: 'XD CAM 50 - GB', label: 'XD CAM 50 - GB'},
          {value: 'XD CAM 23 - GB', label: 'XD CAM 23 - GB'},
          {value: 'DISCO OPTICO 1.5 Tb', label: 'DISCO OPTICO 1.5 Tb'},
        ],
        storageMat: [],
        // itemTelevisa: JSON.parse(this.$localStorage.get("itemTelevisa")), 

      }
    },
    created () {
      this.getSupportMaterials();  
    },
    methods: { 
      addElement (item, index) {
        let code =  {typeStorage: '', codeDisk: ''}
        item.push(code)
      },
      removeElement (item, index) {
        item.splice(index, 1)
      },
      ModalClean () {
        this.clean = true
      },
      enterNewOrder () {
        this.itemTelevisa.infoSupport[0].replacementStorage = false

        if(this.itemTelevisa.infoSupport[0].stateStorage == 'Pendiente' || this.itemTelevisa.infoSupport[0].stateStorage == '' ) {
          this.itemTelevisa.colorBtnStorageSupport = 'info'
          this.itemTelevisa.stateBtnStorageSupport = 'PENDIENTE'       
        } else {
          this.itemTelevisa.colorBtnStorageSupport = 'success'
          this.itemTelevisa.stateBtnStorageSupport = 'COPIADO'  
        }

        HTTP.patch(`materials/${this.itemTelevisa.__id}` , [
          { propName: "stateBtnStorageSupport", value: this.itemTelevisa.stateBtnStorageSupport },
          { propName: "colorBtnStorageSupport", value: this.itemTelevisa.colorBtnStorageSupport },
          { propName: "infoSupport", value: this.itemTelevisa.infoSupport }           
        ])
        .then(res => {
          this.enterSupportModal = true
        })
        .catch(err => console.log(err))
     
      },   
      returnPage () {
        this.$router.push({name: 'almacenTelevisa'})
      },
      getSupportMaterials () {     
        // this.itemSupportMat = this.itemSeleccionado;
        // this.infoSupport = this.itemTelevisa.infoSupport
        console.log(this.itemTelevisa, 'itemTelevisa')

        if(this.itemTelevisa.stateBtnSupport == 'INCOMPLETO') {
          if(this.itemTelevisa.infoSupport[0].replacement == true &&
              this.itemTelevisa.infoSupport[0].replacementStorage == true ) {
                console.log('entre al push')
            let repositionObj = {
              arrivalDate: this.itemTelevisa.infoSupport[0].arrivalDate,
              shippingMode: this.itemTelevisa.infoSupport[0].shippingMode,
              support: this.itemTelevisa.infoSupport[0].support,
              guideNumber: this.itemTelevisa.infoSupport[0].guideNumber,
              supportMaterial: this.itemTelevisa.infoSupport[0].supportMaterial,
              copyBackup: this.itemTelevisa.infoSupport[0].copyBackup,
              dateOfCopy: this.itemTelevisa.infoSupport[0].dateOfCopy,
              storages: this.itemTelevisa.infoSupport[0].storages,
              videoteca: this.itemTelevisa.infoSupport[0].videoteca
            }
            this.itemTelevisa.infoSupport[0].reposicion.push(repositionObj)
            this.itemTelevisa.infoSupport[0].arrivalDate = ''
            this.itemTelevisa.infoSupport[0].shippingMode = ''
            this.itemTelevisa.infoSupport[0].support = ''
            this.itemTelevisa.infoSupport[0].guideNumber = ''
            this.itemTelevisa.infoSupport[0].supportMaterial = [{typeStorage: "", codeDisk: ""}]
            this.itemTelevisa.infoSupport[0].copyBackup = ''
            this.itemTelevisa.infoSupport[0].dateOfCopy = ''
            this.itemTelevisa.infoSupport[0].storages = ''
            this.itemTelevisa.infoSupport[0].videoteca = ''
          } else {
            this.borrarInfo()
          }
        }

      },

      borrarInfo () {
        this.itemTelevisa.infoSupport[0].dateOfCopy = ''
        this.itemTelevisa.infoSupport[0].videoteca = ''
        this.itemTelevisa.infoSupport[0].storages = ''
        this.itemTelevisa.infoSupport[0].stateStorage = 'Pendiente'
        this.itemTelevisa.infoSupport[0].supportMaterial = [{ typeStorage: '', codeDisk: '' }]
        this.itemTelevisa.infoSupport[0].copyBackup = ''

        this.clean = false
      },
      isChooseCopyBackup(val) {
        if(!val || val === '') {
          return true
        } else {
          return false
        }
      }
    },
    computed: {
      isShowTextReplacement() {
        if(this.itemTelevisa && this.itemTelevisa.infoSupport.length > 0) {
          return this.itemTelevisa.infoSupport[0].replacement
        } else {
          return false
        }
      }
    }
  }
</script>


